#include "power_supply.h"

//-------------------------------------------------------------
//------------------ADC interrupt complete vector--------------
ISR(ADC_vect){
	
	//-------------ADC calculation-----------------

	//Update adc_buf from ADC register 
	adc_buf[adc_buf_pointer++] = ADCW;

	//Mask Buf pointer 
	adc_buf_pointer &= 0x03;
	
	//-------------PWM calculation-----------------
	
	//4 new value in buffer?
	if(adc_buf_pointer == 0x03){
		register unsigned char i;
		auto unsigned int temp_adc = 0;
		
		//Calculate Adc_value from ADC buffer
		for(i=0 ; i<4; i++ ){

			temp_adc += adc_buf[i]; 		
		}	 
		
		Adc_value = ((temp_adc>>2) & 0x3FF);

		if(Adc_value < target_adc){
   		
			if(target_pwm < 1023){
				
				target_pwm++;
			}
		}
		else if(Adc_value > target_adc){
			
			if(target_pwm > 0){
				
				target_pwm--;
			}
		}
		//Set new PWM value
		SetPwm(target_pwm);
	}
}

//-------------------------------------------------------------
//------------TIMER 0 Compare Match interrupt vector-----------

ISR(TIMER0_COMPA_vect){
	
	//Update program timers
	t_lcd++;
	t_switch_up++;
	t_switch_down++;
	t_switch_auto++;
}

