#include <avr/io.h>
#include <util/delay.h>
#include <stdlib.h>
#include <avr/interrupt.h>
#include "lcd.h"

//------------------------------------------------------------------------
//						A t t i n y 4 6 1   D r i v e r s  
//------------------------------------------------------------------------

//---------------------- A D C --------------------------------
#define AdcInit()			(ADMUX=0x19, ADCSRA=0xEE,\
						 	 	 DIDR0=0x08, DIDR1=0x60)

//---------------------- P W M --------------------------------
#define PwmInit(){		TCCR1A |= 0x21;\
								DDRB   |= 0x08;\
								PLLCSR |= 0x02;\
								while((PLLCSR & (1<<PLOCK)) == 0);\
								PLLCSR |= 0x04;\
								TCCR1B |= 0x02;}

#define SetPwm(a)			(TC1H=(a>>8), OCR1B =(unsigned char)a)

//-------------- T 0   1 MS   I N T E R R U P T ---------------
#define T0Init()			(TCCR0A |= 1, OCR0A = 255,  \
								 TCCR0B |= 3, TIMSK |= 0x10)					


//-------------- P U S H   B U T T O N S ----------------------

#define ButtonsInit()	(PORTB |= 0x03)
#define SwUp()				(PINB&0x01)									
#define SwDown()			((PINB&0x02)>>1)	

//-------------------------------------------------------------

#define TRUE				1
#define FALSE				0

#define F_CPU 8000000UL

//------------------------------------------------------------------------
//						   D e c l a r a t i o n s  
//------------------------------------------------------------------------

volatile unsigned int target_pwm;
volatile unsigned int target_adc;
volatile unsigned int adc_buf[4];
volatile unsigned char adc_buf_pointer;
volatile unsigned int Adc_value;

//flags
volatile unsigned char switch_up;
volatile unsigned char switch_down;
volatile unsigned char force_LCD_refresh;
volatile unsigned char automatic_advance;
volatile unsigned int  advance_tick;

//Timers
volatile unsigned int t_lcd;
volatile unsigned int t_switch_up;
volatile unsigned int t_switch_down;
volatile unsigned int t_switch_auto;


void AppInit(void);
void LcdRun(void);
void ButtonsRun(void);
